﻿using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows;
using GalaSoft.MvvmLight.Command;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace NavigationGrid 
{
    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Person> _listPersons;
        public ObservableCollection<Person> ListPersons
        {
            get { return _listPersons; }
            set
            {
                _listPersons = value;
                RaisePropertyChanged("ListPersons");
            }
        }

        private Person _persSelected;
        public Person PersSelected
        {
            get { return this._persSelected; }
            set
            {
                _persSelected = value;
                RaisePropertyChanged("PersSelected");
            }
        }

        private bool isBusy;
        public bool IsBusy
        {
            get { return this.isBusy; }
            set
            {
                isBusy = value;
                RaisePropertyChanged("IsBusy");
            }
        }

        public ViewModel()
        {
//            this.AllerPremierCommand = new RelayCommand<object>(AllerPremier);
//            this.AllerPrecedentCommand = new RelayCommand<object>(AllerPrecedent);
//            this.AllerSuivantCommand = new RelayCommand<object>(AllerSuivant);
            this.AllerDernierCommand = new RelayCommand<object>(AllerDernier);

            this.ListPersons = new ObservableCollection<Person>();
            for (int i = 0; i < 1000; i++)
            {
                this.ListPersons.Add(new Person("PersonName" + i, "PersonSurname" + i, "Ingenieur","25","1.77"));
                this.ListPersons.Add(new Person("PersonName" + i, "PersonSurname" + i + "_1", "Ingenieur", "25", "1.77"));
//                this.ListPersons.Add(new Person("PersonName" + i, "PersonSurname" + i + "_2"));
//                this.ListPersons.Add(new Person("PersonName" + i, "PersonSurname" + i + "_3"));
            }

        }

#region Commands
        public RelayCommand<object> AllerPremierCommand { get; set; }
        public RelayCommand<object> AllerPrecedentCommand { get; set; }
        public RelayCommand<object> AllerSuivantCommand { get; set; }
        public RelayCommand<object> AllerDernierCommand { get; set; }

        protected void AllerPremier(object o)
        {
            string premier = this.chercher_premier_item((XamGrid) o);
            this.selectionner_index((XamGrid)o, premier);
            // TODO : griser le bouton 'premier' ET le bouton 'Precedent'
        }

        protected void AllerPrecedent(object o)
        {
            string index = this.recup_index_selectionne((XamGrid) o);

            string precedent = this.chercher_precedent_item((XamGrid) o, index);

            if (precedent != "premier")
                this.selectionner_index((XamGrid)o, precedent);
            else
            {
                // TODO : griser le bouton 'premier' ET le bouton 'Precedent'
            }
        }

        protected void AllerSuivant(object o)
        {
            string index_selectionne = this.recup_index_selectionne((XamGrid)o);

            string prochain = this.chercher_prochain_item((XamGrid)o, index_selectionne);

            if (prochain != "dernier")
                this.selectionner_index((XamGrid)o, prochain);
            else
            {
                // TODO : griser le bouton 'dernier' ET le bouton 'Suivant'
            }
        }


        protected void AllerDernier(object o)
        {
            //string dernierItem = chercher_dernier_item((XamGrid)o);
            //this.selectionner_index((XamGrid)o, dernierItem);
            var grid = (o as XamGrid);
            Row row = grid.Rows[grid.Rows.Count - 1];
            if (row is GroupByRow)
            {
                while (row is GroupByRow)
                {
                    int i = ((GroupByRow)row).Rows.Count;
                    row = ((GroupByRow)row).Rows[i - 1];
                }
            }
            //NOTE : this row take too much time the first time
            grid.ActiveItem = row.Data;
            row.IsSelected = true;
            // TODO : griser le bouton 'dernier' ET le bouton 'Suivant'
        }

#endregion

        private Row precedent = null;


        private bool groupe_apres_index(XamGrid grid, string index)
        {
//            string[] tab = index.Split(';');
//
//            // Alors il n'y a pas de groupes
//            if (tab.Length <= 1)
//                return false;
//            else
//            {
//                int i = int.Parse(tab[tab.Length-1]);
//
//                string s = index.Substring(index.IndexOf(';') + 1);
//
//                if (i + 1 == grid.Rows.Count)
//                    return true;
//            }
//
            return false;
        }

        private bool groupe_apres_index(string index)
        {
//            string[] tab = index.Split(';');
//
//            // Alors il n'y a pas de groupes
//            if (tab.Length <= 1)
//            {
//                int i = int.Parse(tab[0]);
//
//                
//
//
//                if (i + 1 == row.Count)
//                    return true;
//            }
//
            return false;
        }

        private Row recupererGroupe(XamGrid grid, string index)
        {
            string[] tab = index.Split(';');

            if (tab.Length <= 1)
                return null;
            else
            {
                int i = 0;
                string s = index;

                GroupByRow group = null;

                while (i < tab.Length-1)
                {
                    int id = int.Parse(tab[i]);

                    s = s.Substring(index.IndexOf(';') + 1);

                    if (group != null)
                        group = (GroupByRow)group.Rows[id];
                    else
                        group = (GroupByRow)grid.Rows[id];

                    i++;
                }

                return group;
            }
        }


        // Recuperation / Selection d'index dans la grille

        #region selectionner_index

        private void selectionner_index(XamGrid grid, string index)
        {
            string[] tab = index.Split(';');

            // Alors il n'y a pas de groupes
            if (tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);

                // On selectionne la ligne
                grid.Rows[i].IsSelected = true;

                // On deplace la scrollbar
                grid.ScrollCellIntoView(grid.Rows[i].Cells[0]);
            }
            else
            {
                int i = int.Parse(tab[0]);

                string s = index.Substring(index.IndexOf(';') + 1);

                this.selectionner_index_suite(grid.Rows[i], s, grid);
            }

        }


        private void selectionner_index_suite(Row row, string index, XamGrid grid)
        {
            string[] tab = index.Split(';');

            // Si le groupe n'est pas ouvert, on l'ouvre
            if (!row.IsExpanded)
                row.IsExpanded = true;

            if (tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);

                ((GroupByRow) row).Rows[i].IsSelected = true;

                // On deplace la scrollbar
                grid.ScrollCellIntoView(((GroupByRow)row).Rows[i].Cells[0]);
            }
            else
            {
                int i = int.Parse(tab[0]);
                string s = index.Substring(index.IndexOf(';') + 1);
                this.selectionner_index_suite(((GroupByRow)row).Rows[i], s, grid);
            }
        }

        #endregion


        #region recup_index_selectionne

        private string recup_index_selectionne(XamGrid grid)
        {
            int i = 0;
            string ret = "";

            foreach (var row in grid.Rows)
            {
                ret = recup_index_selectionne_suite(row, "" + i);

                if (ret != "-1")
                    break;
                i++;
            }

            // On remet 'precedent' a null
            this.precedent = null;

            return ret;
        }

        private string recup_index_selectionne_suite(Row row, string index)
        {
            // On verifie si la ligne est un groupe
            if (row is GroupByRow)
            {
                // Si le groupe etait ouvert, alors on l'ouvre de nouveau
                if (row.IsExpanded)
                    row.IsExpanded = true;

                int i = 0;

                // Pour chaque lignes du groupe, on rapelle la fonction recursivement
                foreach (var g in ((GroupByRow)row).Rows)
                {
                    string tmp = recup_index_selectionne_suite(g, index + ";" + i);

                    if (tmp != "-1")
                        return tmp;
                    i++;
                }
            }
            // Si c'est une ligne, on verifie si elle etait selectionne
            else
            {
                if (precedent == null)
                    precedent = row;

                if (row.IsSelected)
                {
                    return index;
                }
            }

            return "-1";
        }

        #endregion


        // Precedent


        #region est_premier_element_du_groupe

        private bool est_premier_element_du_groupe(XamGrid grid, string index)
        {
            string[] tab = index.Split(';');

            // Alors il n'y a pas de groupes
            if (tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);
                if (i == 0)
                    return true;
            }
            else
            {
                int i = int.Parse(tab[0]);

                string s = index.Substring(index.IndexOf(';') + 1);

                return this.est_premier_element_du_groupe_suite(grid.Rows[i], s);
            }

            return false;
        }

        private bool est_premier_element_du_groupe_suite(Row row, string index)
        {
            string[] tab = index.Split(';');

            if (tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);

                if (i == 0)
                    return true;
            }
            else
            {
                int i = int.Parse(tab[0]);
                string s = index.Substring(index.IndexOf(';') + 1);
                return this.est_premier_element_du_groupe_suite(((GroupByRow)row).Rows[i], s);
            }

            return false;
        }

        #endregion


        #region chercher_precedent_item

        private string chercher_precedent_item(XamGrid grid, string index)
        {
            string[] tab = index.Split(';');

            // Alors il n'y a pas de groupes
            if (tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);
                if (i == 0)
                    return "premier";
                else
                    return "" + (i - 1);
            }
            else
            {
                string s = index;

                while (true)
                {
                    if (!est_premier_element_du_groupe(grid, s))
                    {

                        string[] tab2 = s.Split(';');
                        int i = int.Parse(tab2[tab2.Length - 1]);

                        // Si il reste des groupes au dessus
                        if (s.Contains(";"))
                        {
                            s = s.Substring(0, s.LastIndexOf(';'));
                            s += ";" + (i - 1);
                        }
                        // Si c'est le debut du tableau 'plus de groupe au desus'
                        else
                            s = "" + (i - 1);

                        // On rajoute l'ensemble des derniers elements de chaques groupes
                        s += this.rajouter_derniers_index_des_groupes(grid, s);

                        break;
                    }

                    if (!s.Contains(";"))
                    {
                        s = "premier";
                        break;
                    }

                    s = s.Substring(0, s.LastIndexOf(';'));
                }

                if (s.Split(';').Length > 0)
                    return s;
                else
                    return "premier";
            }

        }

        private string rajouter_derniers_index_des_groupes(XamGrid grid, string index)
        {
            string[] tab = index.Split(';');

            string ret = "";

            if(tab.Length > 0)
            {
                int id = int.Parse(tab[0]);
                
                Row group = grid.Rows[id];

                int i = 1;

                // On descend jusqu'au niveau souhaite
                while (i < tab.Length)
                {
                    id = int.Parse(tab[i]);
                    group = ((GroupByRow) group).Rows[id];
                    i++;
                }

                // Ensuite on descend jusqu'au dernier element de chaques groupes
                while (group is GroupByRow)
                {
                    ret += ";" + (((GroupByRow) group).Rows.Count -1) ;
                    group = ((GroupByRow) group).Rows[((GroupByRow) group).Rows.Count -1];
                }
            }
            else
            {
                return "";
            }

            return ret;
        }

        #endregion


        #region chercher_premier_item

        private string chercher_premier_item(XamGrid grid)
        {
            string ret = "0";

            if (grid.Rows.Count > 0)
            {
                Row row = grid.Rows[0];

                if (row is GroupByRow)
                {
                    while (row is GroupByRow)
                    {
                        ret += ";0";
                        row = ((GroupByRow) row).Rows[0];
                    }
                }
            }

            return ret;
        }

        #endregion

        // Suivant

        #region chercher_prochain_item

        private string chercher_prochain_item(XamGrid grid, string index)
        {
            string[] tab = index.Split(';');

            // Alors il n'y a pas de groupes
            if (tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);
                if (i + 1 == grid.Rows.Count)
                    return "dernier";
                else
                    return "" + (i + 1);
            }
            else
            {
                string s = index;

                while(true)
                {
                    if (!est_dernier_element_du_groupe(grid, s))
                    {

                        string[] tab2 = s.Split(';');
                        int i = int.Parse(tab2[tab2.Length - 1]);

                        // Si il reste des groupes au dessus
                        if (s.Contains(";"))
                        {
                            s = s.Substring(0, s.LastIndexOf(';'));
                            s += ";" + (i + 1);
                        }
                        // Si c'est le debut du tableau 'plus de groupe au desus'
                        else
                            s = "" + (i + 1);
                        
                        // On rajoute autant de '0' que nessessaires
                        for (int it = (tab2.Length - 1); it < (tab.Length - 1); it++)
                            s += ";0";

                        break;
                    }

                    if (!s.Contains(";"))
                    {
                        s = "dernier";
                        break;
                    }

                    s = s.Substring(0, s.LastIndexOf(';'));
                }

                if (s.Split(';').Length > 0)
                    return s;
                else
                    return "dernier";
            }

        }

        #endregion


        #region est_dernier_element_du_groupe

        private bool est_dernier_element_du_groupe(XamGrid grid, string index)
        {
            string[] tab = index.Split(';');

            // Alors il n'y a pas de groupes
            if(tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);
                if (i + 1 == grid.Rows.Count)
                    return true;
            }
            else
            {
                int i = int.Parse(tab[0]);

                string s = index.Substring(index.IndexOf(';')+1);

                return this.est_dernier_element_du_groupe_suite(grid.Rows[i], s);
            }

            return false;
        }

        private bool est_dernier_element_du_groupe_suite(Row row, string index)
        {
            string[] tab = index.Split(';');

            if(tab.Length <= 1)
            {
                int i = int.Parse(tab[0]);

                if ( i+1 == ((GroupByRow)row).Rows.Count)
                    return true;
            }
            else
            {
                int i = int.Parse(tab[0]);
                string s = index.Substring(index.IndexOf(';') + 1);
                return this.est_dernier_element_du_groupe_suite(((GroupByRow)row).Rows[i], s);
            }

            return false;
        }

        #endregion


        #region chercher_dernier_item

        private string chercher_dernier_item(XamGrid grid)
        {
            string ret = "";

            ret += (grid.Rows.Count - 1);

            Row row = grid.Rows[grid.Rows.Count - 1];

            if (row is GroupByRow)
            {
                while(row is GroupByRow)
                {
                    int i = ((GroupByRow) row).Rows.Count;
                    row = ((GroupByRow) row).Rows[i - 1];

                    ret += ";" + row.Index;
                }
            }

            return ret;
        }

        #endregion



        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisePropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
