﻿using System;
using System.Windows;
using System.Windows.Controls;
using Infragistics.Controls.Grids;

namespace NavigationGrid
{
    public partial class XamGridStones
    {
        public XamGridStones()
        {
            this.DataContext = new ViewModel();
            InitializeComponent();

        }


        /// <summary>
        /// Grille Infragistics sur laquelle appliquer la navigation par boutons
        /// </summary>
        public BusyIndicator XamGrid
        {
            get { return (BusyIndicator)GetValue(XamGridProperty); }
            set
            {
                SetValue(XamGridProperty, value);
            }
        }
//
//        public static event AfficherBusyHandler afficherBusy;
//        public delegate void AfficherBusyHandler(object sender, bool e);


        /// <summary>
        /// Propriete attachee permettant de recuperer la grille Infragistics sur laquelle appliquer la navigation par boutons
        /// </summary>
        public static readonly DependencyProperty XamGridProperty =
            DependencyProperty.Register("XamGrid", typeof(BusyIndicator), typeof(XamGridStones), new PropertyMetadata(null, recupererXamGrid));

        private static void recupererXamGrid(DependencyObject sender, DependencyPropertyChangedEventArgs e)
        {
            XamGridStones nav = (XamGridStones)sender;
            nav.XamGrid = (BusyIndicator)e.NewValue;
        }
    }
}
